; =============================================================================
; paulaquirk v0.1 - 8bitbubsy jan. 2020
;
; Quirk description:
; Makes Paula play from chip mem forever without looping.
; Just a proof of concept, nothing useful...
; =============================================================================

VOL	equ 64

; the three magic constants
LEN1	equ 2274
LEN2	equ 2270
PER	equ 120

	section maincode,CODE
main	; -----------------------------
	move.b	$bfe001,OldLEDStatus	; turn off "LED" filter
	and.b	#%00000001,OldLEDStatus
	bset	#1,$bfe001
	; -----------------------------
	move.w	#$000f,$dff096		; stop audio DMAs
	; -----------------------------
	move.l	#EmptySample,d0		; set up Paula voices
	move.w	#LEN1/2,d1
	move.w	#PER,d2
	moveq	#VOL,d3
	lea	$dff0a0,a0
	moveq	#4-1,d7
.loop	move.l	d0,0(a0)		; location
	move.w	d1,4(a0)		; length
	move.w	d2,6(a0)		; period
	move.w	d3,8(a0)		; volume
	lea	$10(a0),a0
	dbra	d7,.loop	
	; -----------------------------
	move.w	#$800f,$dff096		; start audio DMAs
	bsr.w	WaitForDMALatch
	; -----------------------------
	lea	$dff000,a0		; set new Paula lengths (trigger quirk)
	move.w	#LEN2/2,d0
	move.w	d0,$a4(a0)
	move.w	d0,$b4(a0)
	move.w	d0,$c4(a0)
	move.w	d0,$d4(a0)
	; -----------------------------
mloop	btst	#6,$bfe001		; test if left mouse button is down
	bne.b	mloop
	; -----------------------------
	move.w	#$000f,$dff096		; stop audio DMAs
	and.b	#%11111110,$bfe001	; set back "LED" filter state
	move.b	OldLEDStatus,d0
	or.b	d0,$bfe001
	; -----------------------------
	moveq	#0,d0
	rts
	
WaitForDMALatch			; waits just long enough for Paula DMA to latch
	lea	$dff006,a0
	moveq	#7-1,d1
.loop1	move.b	(a0),d0
.loop2	cmp.b	(a0),d0
	beq.b	.loop2
	dbra	d1,.loop1
	rts

OldLEDStatus	dc.b 0

	section cbuf,DATA_C
	
EmptySample	dcb.b LEN1,0
